//
//  FNOperation.h
//  FNFoundation
//
//  Created by Alexander Rinass on 24/10/15.
//  Copyright © 2015 Fournova GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSInteger, FNOperationState) {
    FNOperationStateInitialized,
    //    FNOperationStatePending,
    //    FNOperationStateReady,
    FNOperationStateExecuting,
    //    FNOperationStateFinishing,
    FNOperationStateFinished
    //    FNOperationStateCancelled
};

@interface FNOperation : NSOperation
@property (atomic, readonly) FNOperationState state;
@property (nonatomic, readonly) NSError *error;

- (void)execute;

- (void)finish;
- (void)finishWithError:(NSError *)error;

- (BOOL)run:(NSError * __autoreleasing *)error;

- (void)operationWillStart;
- (void)operationDidStart;

- (void)operationWillExecute;
- (void)operationDidExecute;

- (void)operationWillFinish;
- (void)operationDidFinish;

@end
